#include "PyError.h"
#include "PyScript.h"


/* Decodes a Python Exception to some human readable string */
string PyError::PyErrorDecode (void) {
    string error_type;
    string error_info;
    string error_string;
    PyObject *errobj, *errdata, *errtraceback;
    PyObject *pystring = NULL;

    if (PyErr_Occurred() != NULL) {
        PyErr_Fetch(&errobj, &errdata, &errtraceback);
        
        if (errobj != NULL && (pystring = PyObject_Str(errobj)) != NULL &&     /* str(object) */
        (PyString_Check(pystring)))
           error_type = string (PyString_AsString(pystring));
        else
           error_type = string ("<Unknown Exception>");
        Py_XDECREF(pystring);
        pystring = NULL;
        
        if (errdata != NULL && (pystring = PyObject_Str(errdata)) != NULL &&
        (PyString_Check(pystring)))
        
            error_info = string (PyString_AsString(pystring));
        else
            error_info = string ("<unknown exception data>"); 
     
        error_string = error_type + " : ";
        error_string += error_info;
        return error_string;
    }
    return string ("No Error happened");
}



void PyError::PyShowError (const char *caption, const char *text1, const char *text2) {
    string outputstring;
/*
    switch (PyScript::ShowErrors) {
        case 0:
            return;
        case 1:
            outputstring = string (text1);  
            break;
        case 2:*/
            outputstring = string (text1);  
            outputstring += "\nError Information from Python:\n";
            outputstring += PyError::PyErrorDecode();
            //break;
  //  }

    MessageBox (NULL, outputstring.c_str(), caption, MB_OK);

}

void PyError::PyShowError (string const caption, const string text1, const string text2) {
    PyError::PyShowError (caption.c_str(), text1.c_str(), text2.c_str());
}
    