#include "PyScript.h"
#include "lsapi.h"
#include "Bangs.h"
#include "PyEmbed.h"
#include "PyExtension.h"
#include "LSAPIBangs.h"
#include <python.h>
#include <windows.h>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

PyScript *module = NULL;

//the step.rc settings & module wide variables
int PyScript::ShowErrors = 2;
HWND PyScript::ParentWnd;
HINSTANCE PyScript::dllInst;

__declspec(dllexport) int initModuleEx (HWND parent, HINSTANCE dllInst, LPCSTR szPath) {
   module = new PyScript(parent, dllInst, szPath);
	return 0;    
}

__declspec(dllexport) void quitModule (HINSTANCE dllInst) {
   if (module != NULL) {
   delete module;	
      module = NULL;
   }

}

PyScript::PyScript (HWND parent, HINSTANCE dllInst, LPCSTR szPath) {
    PyScript::ParentWnd = parent;
    PyScript::dllInst = dllInst;
	Py_Initialize ();
	if (!Py_IsInitialized()) {
		MessageBox(NULL,"PyScript Fatal Error", "Could not initialize Python interpreter. Aborting\n.", MB_OK);
		return;
	}
    LSAPIBangs::Instance ();
    PyExtension::Instance ();
	if (getStepSettings () == false)
   	Bangs::registerBangs ();
}

PyScript::~PyScript () {
	Bangs::unregisterBangs ();
	unloadPythonScripts ();
    Py_Finalize ();
}

bool PyScript::getStepSettings (void) {
	//PyScriptShowErrors setting
    char stringbuf[MAX_LINE_LENGTH+1] = {""};
	GetRCString ("PyScriptShowErrors", stringbuf, "verbose", MAX_LINE_LENGTH);
	if (strcmpi (stringbuf, "no"))
		PyScript::ShowErrors = 0;
	if (strcmpi (stringbuf, "sparse"))
		PyScript::ShowErrors = 1;
	if (strcmpi (stringbuf, "verbose"))
		PyScript::ShowErrors = 2;

    //*PythonPath settings
	char stepbuf[MAX_LINE_LENGTH*10];
	char key[MAX_LINE_LENGTH];
    char expandedvalue[MAX_LINE_LENGTH*2];
	char value[MAX_LINE_LENGTH*2];
	char *tokens[3] = {key,value,NULL};
	FILE *stephandle;

	if ((stephandle = LCOpen (NULL)) == false)
		return false;
	while (LCReadNextConfig (stephandle, "*PyScriptPath", stepbuf, MAX_LINE_LENGTH*10)) {
		LCTokenize (stepbuf, tokens, 2, NULL);
        VarExpansionEx (expandedvalue, value, sizeof (expandedvalue));
		if (!PyEmbed::addPythonPath (string(expandedvalue)))
			return false;
	}
	LCClose (stephandle);

	if ((stephandle = LCOpen (NULL)) == false)
		return false;
	while (LCReadNextConfig (stephandle, "*PyScriptFile", stepbuf, MAX_LINE_LENGTH*10)) {  
        LCTokenize (stepbuf, tokens, 2, NULL);
		if (!PyEmbed::loadPythonScript (string(value)))
			return false;
   	}
	return true;
}

void PyScript::unloadPythonScripts (void) {
    /*string scriptpath;
    vector<string>::iterator pos = PyEmbed::scriptnames.end();

    while (pos) {
        pos = PyEmbed::scriptnames.end();
        scriptpath = PyEmbed::scriptnames.at (pos);
    }


    

    for (unsigned int i=0;i<PyEmbed::scriptnames.size();i++) {
        PyEmbed::unloadPythonScript (PyEmbed::scriptnames[i]);
        PyEmbed::scriptnames.erase (PyEmbed::scriptnames[i]);
    }*/
}

void PyScript::deregisterBangs (void) {
}


